'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsShallowCompare = require('react-addons-shallow-compare');

var _reactAddonsShallowCompare2 = _interopRequireDefault(_reactAddonsShallowCompare);

var _Grid = require('../Grid');

var _Grid2 = _interopRequireDefault(_Grid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Renders 1, 2, or 4 Grids depending on configuration.
 * A main (body) Grid will always be rendered.
 * Optionally, 1-2 Grids for sticky header rows will also be rendered.
 * If no sticky columns, only 1 sticky header Grid will be rendered.
 * If sticky columns, 2 sticky header Grids will be rendered.
 */
var MultiGrid = function (_Component) {
  _inherits(MultiGrid, _Component);

  function MultiGrid(props, context) {
    _classCallCheck(this, MultiGrid);

    var _this = _possibleConstructorReturn(this, (MultiGrid.__proto__ || Object.getPrototypeOf(MultiGrid)).call(this, props, context));

    _this.state = {
      scrollLeft: 0,
      scrollTop: 0
    };

    _this._cellRendererBottomLeftGrid = _this._cellRendererBottomLeftGrid.bind(_this);
    _this._cellRendererBottomRightGrid = _this._cellRendererBottomRightGrid.bind(_this);
    _this._cellRendererTopRightGrid = _this._cellRendererTopRightGrid.bind(_this);
    _this._columnWidthRightGrid = _this._columnWidthRightGrid.bind(_this);
    _this._onScrollHorizontal = _this._onScrollHorizontal.bind(_this);
    _this._onScrollVertical = _this._onScrollVertical.bind(_this);
    _this._rowHeightBottomGrid = _this._rowHeightBottomGrid.bind(_this);
    return _this;
  }

  _createClass(MultiGrid, [{
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      var _props = this.props;
      var columnWidth = _props.columnWidth;
      var fixedColumnCount = _props.fixedColumnCount;
      var fixedRowCount = _props.fixedRowCount;
      var rowHeight = _props.rowHeight;


      if (columnWidth !== nextProps.columnWidth || fixedColumnCount !== nextProps.fixedColumnCount) {
        this._leftGridWidth = null;
      }

      if (fixedRowCount !== nextProps.fixedRowCount || rowHeight !== nextProps.rowHeight) {
        this._topGridHeight = null;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props;
      var height = _props2.height;
      var style = _props2.style;
      var width = _props2.width;
      var _state = this.state;
      var scrollLeft = _state.scrollLeft;
      var scrollTop = _state.scrollTop;


      return _react2.default.createElement(
        'div',
        {
          style: _extends({
            height: height,
            width: width
          }, style)
        },
        _react2.default.createElement(
          'div',
          {
            style: {
              height: this._getTopGridHeight(),
              position: 'relative',
              width: width
            }
          },
          this._renderTopLeftGrid(),
          this._renderTopRightGrid({ scrollLeft: scrollLeft })
        ),
        _react2.default.createElement(
          'div',
          {
            onScroll: this._onScrollVertical,
            ref: function ref(_ref) {
              _this2._scrollingContainer = _ref;
            },
            style: {
              height: height - this._getTopGridHeight(),
              overflowY: 'auto',
              position: 'relative',
              width: width
            }
          },
          this._renderBottomLeftGrid({ scrollTop: scrollTop }),
          this._renderBottomRightGrid({ scrollTop: scrollTop })
        )
      );
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _reactAddonsShallowCompare2.default)(this, nextProps, nextState);
    }
  }, {
    key: '_cellRendererBottomLeftGrid',
    value: function _cellRendererBottomLeftGrid(_ref2) {
      var rowIndex = _ref2.rowIndex;

      var rest = _objectWithoutProperties(_ref2, ['rowIndex']);

      var _props3 = this.props;
      var cellRenderer = _props3.cellRenderer;
      var fixedRowCount = _props3.fixedRowCount;


      return cellRenderer(_extends({}, rest, {
        rowIndex: rowIndex + fixedRowCount
      }));
    }
  }, {
    key: '_cellRendererBottomRightGrid',
    value: function _cellRendererBottomRightGrid(_ref3) {
      var columnIndex = _ref3.columnIndex;
      var rowIndex = _ref3.rowIndex;

      var rest = _objectWithoutProperties(_ref3, ['columnIndex', 'rowIndex']);

      var _props4 = this.props;
      var cellRenderer = _props4.cellRenderer;
      var fixedRowCount = _props4.fixedRowCount;


      return cellRenderer(_extends({}, rest, {
        columnIndex: columnIndex + columnIndex,
        rowIndex: rowIndex + fixedRowCount
      }));
    }
  }, {
    key: '_cellRendererTopRightGrid',
    value: function _cellRendererTopRightGrid(_ref4) {
      var columnIndex = _ref4.columnIndex;

      var rest = _objectWithoutProperties(_ref4, ['columnIndex']);

      var cellRenderer = this.props.cellRenderer;


      return cellRenderer(_extends({}, rest, {
        columnIndex: columnIndex + columnIndex
      }));
    }
  }, {
    key: '_columnWidthRightGrid',
    value: function _columnWidthRightGrid(index) {
      var _props5 = this.props;
      var fixedColumnCount = _props5.fixedColumnCount;
      var columnWidth = _props5.columnWidth;


      return columnWidth instanceof Function ? columnWidth(index + fixedColumnCount) : columnWidth;
    }
  }, {
    key: '_getBottomGridHeight',
    value: function _getBottomGridHeight() {
      var height = this.props.height;


      var topGridHeight = this._getTopGridHeight();

      return height - topGridHeight;
    }
  }, {
    key: '_getLeftGridWidth',
    value: function _getLeftGridWidth() {
      var _props6 = this.props;
      var fixedColumnCount = _props6.fixedColumnCount;
      var columnWidth = _props6.columnWidth;


      if (this._leftGridWidth == null) {
        if (columnWidth instanceof Function) {
          var leftGridWidth = 0;

          for (var index = 0; index < fixedColumnCount; index++) {
            leftGridWidth += columnWidth(index);
          }

          this._leftGridWidth = leftGridWidth;
        } else {
          this._leftGridWidth = columnWidth * fixedColumnCount;
        }
      }

      return this._leftGridWidth;
    }
  }, {
    key: '_getRightGridWidth',
    value: function _getRightGridWidth() {
      var width = this.props.width;


      var leftGridWidth = this._getLeftGridWidth();

      return width - leftGridWidth;
    }
  }, {
    key: '_getTopGridHeight',
    value: function _getTopGridHeight() {
      var _props7 = this.props;
      var fixedRowCount = _props7.fixedRowCount;
      var rowHeight = _props7.rowHeight;


      if (this._topGridHeight == null) {
        if (rowHeight instanceof Function) {
          var topGridHeight = 0;

          for (var index = 0; index < fixedRowCount; index++) {
            topGridHeight += rowHeight(index);
          }

          this._topGridHeight = topGridHeight;
        } else {
          this._topGridHeight = rowHeight * fixedRowCount;
        }
      }

      return this._topGridHeight;
    }
  }, {
    key: '_onScrollHorizontal',
    value: function _onScrollHorizontal(_ref5) {
      var scrollLeft = _ref5.scrollLeft;

      this.setState({
        scrollLeft: scrollLeft
      });
    }
  }, {
    key: '_onScrollVertical',
    value: function _onScrollVertical(event) {
      if (event.target !== this._scrollingContainer) {
        return;
      }

      this.setState({
        scrollTop: event.target.scrollTop
      });
    }
  }, {
    key: '_renderBottomLeftGrid',
    value: function _renderBottomLeftGrid(_ref6) {
      var scrollTop = _ref6.scrollTop;
      var _props8 = this.props;
      var fixedColumnCount = _props8.fixedColumnCount;
      var fixedRowCount = _props8.fixedRowCount;
      var rowCount = _props8.rowCount;
      var styleBottomLeftGrid = _props8.styleBottomLeftGrid;


      if (!fixedColumnCount) {
        return null;
      }

      return _react2.default.createElement(_Grid2.default, _extends({}, this.props, {
        autoHeight: true,
        cellRenderer: this._cellRendererBottomLeftGrid,
        columnCount: fixedColumnCount,
        height: this._getBottomGridHeight(),
        rowCount: rowCount - fixedRowCount,
        rowHeight: this._rowHeightBottomGrid,
        scrollTop: scrollTop,
        style: _extends({
          height: 'auto',
          left: 0,
          outline: 0,
          position: 'absolute'
        }, styleBottomLeftGrid),
        width: this._getLeftGridWidth()
      }));
    }
  }, {
    key: '_renderBottomRightGrid',
    value: function _renderBottomRightGrid(_ref7) {
      var scrollTop = _ref7.scrollTop;
      var _props9 = this.props;
      var columnCount = _props9.columnCount;
      var fixedColumnCount = _props9.fixedColumnCount;
      var fixedRowCount = _props9.fixedRowCount;
      var rowCount = _props9.rowCount;
      var styleBottomRightGrid = _props9.styleBottomRightGrid;


      return _react2.default.createElement(_Grid2.default, _extends({}, this.props, {
        autoHeight: true,
        cellRenderer: this._cellRendererBottomRightGrid,
        columnCount: columnCount - fixedColumnCount,
        columnWidth: this._columnWidthRightGrid,
        height: this._getBottomGridHeight(),
        onScroll: this._onScrollHorizontal,
        rowCount: rowCount - fixedRowCount,
        rowHeight: this._rowHeightBottomGrid,
        scrollTop: scrollTop,
        style: _extends({
          height: 'auto',
          left: this._getLeftGridWidth(),
          outline: 0,
          position: 'absolute'
        }, styleBottomRightGrid),
        width: this._getRightGridWidth()
      }));
    }
  }, {
    key: '_renderTopLeftGrid',
    value: function _renderTopLeftGrid() {
      var _props10 = this.props;
      var fixedColumnCount = _props10.fixedColumnCount;
      var fixedRowCount = _props10.fixedRowCount;
      var styleTopLeftGrid = _props10.styleTopLeftGrid;


      if (!fixedColumnCount || !fixedRowCount) {
        return null;
      }

      return _react2.default.createElement(_Grid2.default, _extends({}, this.props, {
        columnCount: fixedColumnCount,
        height: this._getTopGridHeight(),
        rowCount: fixedRowCount,
        style: _extends({
          left: 0,
          outline: 0,
          position: 'absolute',
          top: 0
        }, styleTopLeftGrid),
        width: this._getLeftGridWidth()
      }));
    }
  }, {
    key: '_renderTopRightGrid',
    value: function _renderTopRightGrid(_ref8) {
      var scrollLeft = _ref8.scrollLeft;
      var _props11 = this.props;
      var columnCount = _props11.columnCount;
      var fixedColumnCount = _props11.fixedColumnCount;
      var fixedRowCount = _props11.fixedRowCount;
      var styleTopRightGrid = _props11.styleTopRightGrid;


      if (!fixedRowCount) {
        return null;
      }

      return _react2.default.createElement(_Grid2.default, _extends({}, this.props, {
        cellRenderer: this._cellRendererTopRightGrid,
        columnCount: columnCount - fixedColumnCount,
        columnWidth: this._columnWidthRightGrid,
        height: this._getTopGridHeight(),
        rowCount: fixedRowCount,
        scrollLeft: scrollLeft,
        style: _extends({
          left: this._getLeftGridWidth(),
          outline: 0,
          position: 'absolute',
          top: 0
        }, styleTopRightGrid),
        width: this._getRightGridWidth()
      }));
    }
  }, {
    key: '_rowHeightBottomGrid',
    value: function _rowHeightBottomGrid(index) {
      var _props12 = this.props;
      var fixedRowCount = _props12.fixedRowCount;
      var rowHeight = _props12.rowHeight;


      return rowHeight instanceof Function ? rowHeight(index + fixedRowCount) : rowHeight;
    }
  }]);

  return MultiGrid;
}(_react.Component);

MultiGrid.defaultProps = {
  fixedColumnCount: 0,
  fixedRowCount: 0,
  style: {},
  styleBottomLeftGrid: {},
  styleBottomRightGrid: {},
  styleTopLeftGrid: {},
  styleTopRightGrid: {}
};
exports.default = MultiGrid;
process.env.NODE_ENV !== "production" ? MultiGrid.propTypes = {
  fixedColumnCount: _react.PropTypes.number.isRequired,
  fixedRowCount: _react.PropTypes.number.isRequired,
  style: _react.PropTypes.object.isRequired,
  styleBottomLeftGrid: _react.PropTypes.object.isRequired,
  styleBottomRightGrid: _react.PropTypes.object.isRequired,
  styleTopLeftGrid: _react.PropTypes.object.isRequired,
  styleTopRightGrid: _react.PropTypes.object.isRequired
} : void 0;